Index: CMT/v1r25-branch/source/cmt_symbol.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_symbol.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_symbol.cxx	(revision 664)
@@ -3306,5 +3679,200 @@
       case CommandMacroRemoveAllRegexp :
 	//case CommandAction :
-	if (value.text == "") return result;
+	if (value.text.size () == 0) return result;
+        break;
+    }
+
+  CmtError::code code (CmtError::ok);
+  cmt_string msg, n;
+  int exec_err (0);
+
+  switch (command_type)
+    {
+      case CommandSet :
+      case CommandSetAppend :
+      case CommandSetPrepend :
+      case CommandSetRemove :
+      case CommandSetRemoveRegexp :
+
+	if (CmtError::has_pending_error ())
+	  {
+	    code = CmtError::get_last_error_code ();
+	    msg = CmtError::get_last_error ();
+	    exec_err = CmtError::get_last_execution_error ();
+	    n = CmtError::get_error_name (code);
+	    CmtError::clear ();
+	  }
+	resolve_value_for_macros (rvalue);
+	if (CmtError::get_last_error_code () != CmtError::warning)
+	  {
+	    if (CmtError::has_pending_error ())
+	      {
+		CmtError::print ();
+		CmtError::clear ();
+	      }
+	    if (CmtError::ok != code)
+	      {
+		// restore error occurred before value expansion
+		CmtError::set (code,
+			       (msg.replace (n + ": ", cmt_string ("")), msg),
+			       exec_err);
+	      }
+	    if (CommandSet != command_type &&
+		rvalue.size () == 0)
+	      return result;
+	  }
+	else
+	  {
+	    if (CmtMessage::active (Verbose))
+	      CmtError::print ();
+	    CmtError::clear ();
+	    if (CmtError::ok != code)
+	      {
+		// restore error occurred before value expansion
+		CmtError::set (code,
+			       (msg.replace (n + ": ", cmt_string ("")), msg),
+			       exec_err);
+	      }
+	    // Ignore the error, keep the value unresolved
+	    rvalue = value.text;
+	  }
+
+        break;
+
+	//case CommandAlias :
+      case CommandPath :
+      case CommandPathAppend :
+      case CommandPathPrepend :
+      case CommandPathRemove :
+      case CommandPathRemoveRegexp :
+	//case CommandMacroPrepend :
+	//case CommandMacro :
+	//case CommandMacroAppend :
+	//case CommandMacroRemove :
+	//case CommandMacroRemoveRegexp :
+	//case CommandMacroRemoveAll :
+	//case CommandMacroRemoveAllRegexp :
+	//case CommandAction :
+
+	if (!pb)
+	  pb = static_cast<PathBuilder*> (symbol.builder);
+	if (pb->get_strip_path ())
+	  {
+	    /*
+	    CmtError::code code (CmtError::ok);
+	    cmt_string msg, n;
+	    int exec_err (0);
+	    */
+	    if (CmtError::has_pending_error ())
+	      {
+		code = CmtError::get_last_error_code ();
+		msg = CmtError::get_last_error ();
+		exec_err = CmtError::get_last_execution_error ();
+		n = CmtError::get_error_name (code);
+		CmtError::clear ();
+	      }
+	    resolve_value (rvalue);
+	    if (CmtError::get_last_error_code () != CmtError::warning)
+	      {
+		if (CmtError::has_pending_error ())
+		  {
+		    CmtError::print ();
+		    CmtError::clear ();
+		  }
+		if (CmtError::ok != code)
+		  {
+		    // restore error occurred before value expansion
+		    CmtError::set (code,
+				   (msg.replace (n + ": ", cmt_string ("")), msg),
+				   exec_err);
+		  }
+		if (CommandPath != command_type &&
+		    rvalue.size () == 0)
+		  return result;
+	      }
+	    else
+	      {
+		if (CommandPathRemove == command_type ||
+		    CommandPathRemoveRegexp == command_type)
+		  {
+		    // This means that the value is not resolved via symbols
+		    // and, possibly, standard environment variables and
+		    //   * either has no effect on the path at all,
+		    //     or
+		    //   * there should be similar contribution from
+		    //     and, hence, we should get the same error with 
+		    //     CommandPath, CommandPathAppend, or CommandPathPrepend
+		    //  Either way, we can ignore this error.
+
+		    if (CmtMessage::active (Verbose))
+		      CmtError::print ();
+		    CmtError::clear ();
+		    if (CmtError::ok != code)
+		      {
+			// restore error occurred before value expansion
+			CmtError::set (code,
+				       (msg.replace (n + ": ", cmt_string ("")), msg),
+				       exec_err);
+		      }
+		  }
+		else if (CmtError::ok != code)
+		  {
+		    // print error occurred before value expansion
+		    CmtMessage::error (msg);
+		  }
+		// We keep CmtError::warning to indicate that
+		// we could not resolve path
+		// (without referencing the environment)
+		// and strip path of non-existent directories
+		//
+		rvalue = value.text;
+	      }
+	  }
+	else // (!pb->get_strip_path ())
+	  {
+	    if (CmtError::has_pending_error ())
+	      {
+		code = CmtError::get_last_error_code ();
+		msg = CmtError::get_last_error ();
+		exec_err = CmtError::get_last_execution_error ();
+		n = CmtError::get_error_name (code);
+		CmtError::clear ();
+	      }
+	    resolve_value_for_macros (rvalue);
+	    if (CmtError::get_last_error_code () != CmtError::warning)
+	      {
+		if (CmtError::has_pending_error ())
+		  {
+		    CmtError::print ();
+		    CmtError::clear ();
+		  }
+		if (CmtError::ok != code)
+		  {
+		    // restore error occurred before value expansion
+		    CmtError::set (code,
+				   (msg.replace (n + ": ", cmt_string ("")), msg),
+				   exec_err);
+		  }
+		if (CommandPath != command_type &&
+		    rvalue.size () == 0)
+		  return result;
+	      }
+	    else
+	      {
+		if (CmtMessage::active (Verbose))
+		  CmtError::print ();
+		CmtError::clear ();
+		if (CmtError::ok != code)
+		  {
+		    // restore error occurred before value expansion
+		    CmtError::set (code,
+				   (msg.replace (n + ": ", cmt_string ("")), msg),
+				   exec_err);
+		  }
+		// Ignore the error, keep the value unresolved
+		rvalue = value.text;
+	      }
+	  }
+
         break;
     }
@@ -3317,11 +3885,5 @@
 
   if (CmtMessage::active (Verbose))
-    cout << "# Package " << (use != 0 ? use->get_package_name () + " " + use->version : "");
-  /*
-  if (use != 0)
-    {
-      cout << use->get_package_name () << " " << use->version;
-    }
-  */
+    out << "# Package " << (use ? use->get_package_name () + " " + use->version : "");
 
   switch (command_type)
@@ -3329,7 +3891,7 @@
       case CommandSet :
 	if (CmtMessage::active (Verbose))
-	  cout << " " << define_text << " set " << symbol.name << " as " << endl;
-	//        cout << " " << define_text << " set " << symbol.name << " as ";
-        cout << "set " << symbol.name;
+	  out << " " << define_text << " set " << symbol.name << " as " << endl;
+	//        out << " " << define_text << " set " << symbol.name << " as ";
+        out << "set " << symbol.name;
         first_definition = false;
 	result = 1;
@@ -3337,43 +3899,51 @@
       case CommandSetAppend :
 	if (CmtMessage::active (Verbose))
-	  cout << " appends to set " << symbol.name << " : " << endl;
-	//        cout << " appends to set " << symbol.name << " : ";
-        cout << "set_append " << symbol.name;
+	  out << " appends to set " << symbol.name << " : " << endl;
+	//        out << " appends to set " << symbol.name << " : ";
+        out << "set_append " << symbol.name;
 	result = 1;
         break;
       case CommandSetPrepend :
 	if (CmtMessage::active (Verbose))
-	  cout << " prepends to set " << symbol.name << " : " << endl;
-	//        cout << " prepends to set " << symbol.name << " : ";
-        cout << "set_prepend " << symbol.name;
+	  out << " prepends to set " << symbol.name << " : " << endl;
+	//        out << " prepends to set " << symbol.name << " : ";
+        out << "set_prepend " << symbol.name;
 	result = 1;
         break;
       case CommandSetRemove :
 	if (CmtMessage::active (Verbose))
-	  cout << " removes from set " << symbol.name << " : " << endl;
-	//        cout << " removes from set " << symbol.name << " : ";
-        cout << "set_remove " << symbol.name;
+	  out << " removes from set " << symbol.name << " : " << endl;
+	//        out << " removes from set " << symbol.name << " : ";
+        out << "set_remove " << symbol.name;
 	result = 1;
         break;
       case CommandSetRemoveRegexp :
 	if (CmtMessage::active (Verbose))
-	  cout << " removes RE from set " << symbol.name << " : " << endl;
-	//        cout << " removes RE from set " << symbol.name << " : ";
-        cout << "set_remove_regexp " << symbol.name;
+	  out << " removes RE from set " << symbol.name << " : " << endl;
+	//        out << " removes RE from set " << symbol.name << " : ";
+        out << "set_remove_regexp " << symbol.name;
 	result = 1;
         break;
       case CommandAlias :
 	if (CmtMessage::active (Verbose))
-	  cout << " " << define_text << " alias " << symbol.name << endl;
-	//        cout << " " << define_text << " alias " << symbol.name << " as ";
-        cout << "alias " << symbol.name;
+	  out << " " << define_text << " alias " << symbol.name << endl;
+	//        out << " " << define_text << " alias " << symbol.name << " as ";
+        out << "alias " << symbol.name;
         first_definition = false;
 	result = 1;
         break;
-      case CommandPath :
+    case CommandPath :
 	if (CmtMessage::active (Verbose))
-	  cout << " " << define_text << " path " << symbol.name << endl;
-	//        cout << " " << define_text << " path " << symbol.name << " as ";
-        cout << "path " << symbol.name;
+	  out << " " << define_text << " path " << symbol.name << endl;
+	//        out << " " << define_text << " path " << symbol.name << " as ";
+	pb->filter_path_value (symbol, rvalue);
+
+	if (Cmt::get_debug ())
+	  {
+	    cerr << "|SymbolValueList::print> path " << symbol.name
+		 << " " << value.text << " => " << rvalue << endl;
+	  }
+
+        out << "path " << symbol.name;
         first_definition = false;
 	result = 1;
@@ -3381,84 +3951,116 @@
       case CommandPathAppend :
 	if (CmtMessage::active (Verbose))
-	  cout << " appends to path " << symbol.name << endl;
-	//        cout << " appends to path " << symbol.name << " : ";
-        cout << "path_append " << symbol.name;
+	  out << " appends to path " << symbol.name << endl;
+	//        out << " appends to path " << symbol.name << " : ";
+	pb->filter_path_value (symbol, rvalue);
+
+	if (Cmt::get_debug ())
+	  {
+	    cerr << "|SymbolValueList::print> path_append " << symbol.name
+		 << " " << value.text << " => " << rvalue << endl;
+	  }
+
+	if (rvalue.size () == 0) return result;
+        out << "path_append " << symbol.name;
 	result = 1;
         break;
       case CommandPathPrepend :
 	if (CmtMessage::active (Verbose))
-	  cout << " prepends to path " << symbol.name << " : " << endl;
-	//        cout << " prepends to path " << symbol.name << " : ";
-        cout << "path_prepend " << symbol.name;
+	  out << " prepends to path " << symbol.name << " : " << endl;
+	//        out << " prepends to path " << symbol.name << " : ";
+	pb->filter_path_value (symbol, rvalue);
+
+	if (Cmt::get_debug ())
+	  {
+	    cerr << "|SymbolValueList::print> path_prepend " << symbol.name
+		 << " " << value.text << " => " << rvalue << endl;
+	  }
+
+	if (rvalue.size () == 0) return result;
+        out << "path_prepend " << symbol.name;
 	result = 1;
         break;
       case CommandPathRemove :
 	if (CmtMessage::active (Verbose))
-	  cout << " removes from path " << symbol.name << " : " << endl;
-	//        cout << " removes from path " << symbol.name << " : ";
-        cout << "path_remove " << symbol.name;
+	  out << " removes from path " << symbol.name << " : " << endl;
+	//        out << " removes from path " << symbol.name << " : ";
+
+	if (Cmt::get_debug ())
+	  {
+	    cerr << "|SymbolValueList::print> path_remove " << symbol.name
+		 << " " << value.text << " => " << rvalue << endl;
+	  }
+
+        out << "path_remove " << symbol.name;
 	result = 1;
         break;
       case CommandPathRemoveRegexp :
 	if (CmtMessage::active (Verbose))
-	  cout << " removes RE from path " << symbol.name << " : " << endl;
-	//        cout << " removes RE from path " << symbol.name << " : ";
-        cout << "path_remove_regexp " << symbol.name;
+	  out << " removes RE from path " << symbol.name << " : " << endl;
+	//        out << " removes RE from path " << symbol.name << " : ";
+
+	if (Cmt::get_debug ())
+	  {
+	    cerr << "|SymbolValueList::print> path_remove_regexp " << symbol.name
+		 << " " << value.text << " => " << rvalue << endl;
+	  }
+
+        out << "path_remove_regexp " << symbol.name;
 	result = 1;
         break;
       case CommandMacro :
 	if (CmtMessage::active (Verbose))
-	  cout << " " << define_text << " macro " << symbol.name << " as " << endl;
-	//        cout << " " << define_text << " macro " << symbol.name << " as ";
-        cout << "macro " << symbol.name;
+	  out << " " << define_text << " macro " << symbol.name << " as " << endl;
+	//        out << " " << define_text << " macro " << symbol.name << " as ";
+        out << "macro " << symbol.name;
 	result = 1;
         break;
       case CommandMacroPrepend :
 	if (CmtMessage::active (Verbose))
-	  cout << " prepends to macro " << symbol.name << " : " << endl;
-	//        cout << " prepends to macro " << symbol.name << " : ";
-        cout << "macro_prepend " << symbol.name;
+	  out << " prepends to macro " << symbol.name << " : " << endl;
+	//        out << " prepends to macro " << symbol.name << " : ";
+        out << "macro_prepend " << symbol.name;
 	result = 1;
         break;
       case CommandMacroAppend :
 	if (CmtMessage::active (Verbose))
-	  cout << " appends to macro " << symbol.name << " : " << endl;
-	//        cout << " appends to macro " << symbol.name << " : ";
-        cout << "macro_append " << symbol.name;
+	  out << " appends to macro " << symbol.name << " : " << endl;
+	//        out << " appends to macro " << symbol.name << " : ";
+        out << "macro_append " << symbol.name;
 	result = 1;
         break;
       case CommandMacroRemove :
 	if (CmtMessage::active (Verbose))
-	  cout << " remove from macro " << symbol.name << " : " << endl;
-	//        cout << " remove from macro " << symbol.name << " : ";
-        cout << "macro_remove " << symbol.name;
+	  out << " remove from macro " << symbol.name << " : " << endl;
+	//        out << " remove from macro " << symbol.name << " : ";
+        out << "macro_remove " << symbol.name;
 	result = 1;
         break;
       case CommandMacroRemoveRegexp :
 	if (CmtMessage::active (Verbose))
-	  cout << " remove RE from macro " << symbol.name << " : " << endl;
-	//        cout << " remove RE from macro " << symbol.name << " : ";
-        cout << "macro_remove_regexp " << symbol.name;
+	  out << " remove RE from macro " << symbol.name << " : " << endl;
+	//        out << " remove RE from macro " << symbol.name << " : ";
+        out << "macro_remove_regexp " << symbol.name;
 	result = 1;
         break;
       case CommandMacroRemoveAll :
 	if (CmtMessage::active (Verbose))
-	  cout << " remove all from macro " << symbol.name << " : " << endl;
-	//        cout << " remove all from macro " << symbol.name << " : ";
-        cout << "macro_remove_all " << symbol.name;
+	  out << " remove all from macro " << symbol.name << " : " << endl;
+	//        out << " remove all from macro " << symbol.name << " : ";
+        out << "macro_remove_all " << symbol.name;
 	result = 1;
         break;
       case CommandMacroRemoveAllRegexp :
 	if (CmtMessage::active (Verbose))
-	  cout << " remove all RE from macro " << symbol.name << " : " << endl;
-	//        cout << " remove all RE from macro " << symbol.name << " : ";
-        cout << "macro_remove_all_regexp " << symbol.name;
+	  out << " remove all RE from macro " << symbol.name << " : " << endl;
+	//        out << " remove all RE from macro " << symbol.name << " : ";
+        out << "macro_remove_all_regexp " << symbol.name;
 	result = 1;
         break;
       case CommandSetupScript :
 	if (CmtMessage::active (Verbose))
-	  cout << " " << define_text << " setup script " << symbol.name << endl;
-	//       cout << " " << define_text << " action " << symbol.name << " as ";
-        cout << "setup_script" /* << symbol.name */;
+	  out << " " << define_text << " setup script " << symbol.name << endl;
+	//       out << " " << define_text << " action " << symbol.name << " as ";
+        out << "setup_script" /* << symbol.name */;
         first_definition = false;
 	result = 1;
@@ -3466,5 +4068,5 @@
 	/*
       case CommandAction :
-        cout << " " << define_text << " action " << symbol.name << " as ";
+        out << " " << define_text << " action " << symbol.name << " as ";
         first_definition = false;
         break;
@@ -3472,6 +4074,7 @@
     }
 
-  cout << " " << CmtSystem::quote (value.text, " \t");
-  //  cout << "'" << value.text << "'";
+  out << " " << CmtSystem::quote (rvalue, " \t");
+  //  out << " " << CmtSystem::quote (value.text, " \t");
+  //  out << "'" << value.text << "'";
           
   /*
@@ -3481,14 +4084,14 @@
       (selected_tag == Tag::get_default ()))
     {
-      cout << " for default tag";
+      out << " for default tag";
     }
   else
     {
-      cout << " for tag '" << selected_tag->get_name () << "'";
+      out << " for tag '" << selected_tag->get_name () << "'";
     }
   */
 
-  cout << endl;
-  //  cout << discarded_text << endl;
+  out << endl;
+  //  out << discarded_text << endl;
   return result;
 }
@@ -3547,5 +4150,25 @@
   else
     {
+		if (Cmt::get_env_access () ||
+		    Symbol::std_env_vars ().has (name))
+		  {
       s = CmtSystem::getenv (name);
+		    if (Cmt::get_debug ())
+		      {
+			cerr << "Symbol::get_env_value> getenv (" << name
+			     << ") => " << s << endl;
+		      }
+		  }
+		else
+		  {
+		    if (Cmt::get_debug ())
+		      {
+			cerr << "Symbol::get_env_value> getenv (" << name
+			     << ") denied" << endl;
+		      }
+		    CmtError::set (CmtError::warning,
+				   "getenv (" + name + ") denied");
+		    return (s);
+		  }
     }
 
Index: CMT/v1r25-branch/source/cmt_symbol.h
===================================================================
--- CMT/v1r25-branch/source/cmt_symbol.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt_symbol.h	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
@@ -34,5 +35,5 @@
   int select_last () const;
   void show (const Symbol& symbol, const SymbolValue& value, bool& first_definition) const;
-  int print (const Symbol& symbol, const SymbolValue& value, bool& first_definition) const;
+  int print (const Symbol& symbol, const SymbolValue& value, bool& first_definition, ostream& out = cout) const;
 
   CommandType command_type;
@@ -89,5 +90,6 @@
 
   static void all_set ();
-  static void all_print (PrintMode mode);
+  static void all_print (PrintMode mode, ostream& out = cout);
+  //static void all_print (PrintMode mode);
   static void all_print_clean (PrintMode mode);
   static void check_all_paths ();
@@ -96,4 +98,5 @@
   static SymbolVector& symbols ();
   static SymbolMap& symbol_map ();
+  static SymbolMap& std_env_vars ();
   static Symbol& symbol (int index);
   static void clear_all ();
@@ -107,4 +110,5 @@
 
   static bool get_inhibit_display ();
+  static bool set_strip_path (const bool& strip_path);
 
 public:
@@ -118,5 +122,6 @@
 
   int print_clean (PrintMode mode);
-  int print (PrintMode mode);
+  int print (PrintMode mode, ostream& out = cout);
+  //int print (PrintMode mode);
   cmt_string build_macro_value (bool display_it = false) const;
   int print_macro (PrintMode mode, ostream& out = cout) const;
Index: CMT/v1r25-branch/source/cmt_syntax.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_syntax.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_syntax.cxx	(revision 664)
@@ -3,4 +3,5 @@
 // arnault@lal.in2p3.fr
 // Modified by garonne@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
@@ -212,5 +213,5 @@
 	       int line_number)
   {
-        
+    /*        
     cmt_string cmtpath;
     cmt_string offset;
@@ -219,4 +220,7 @@
 
     Project* p = Project::find_by_cmtpath (cmtpath);
+    */
+    Project* p = const_cast<Project*>(use->get_project ());
+    //    const Project* p = use->get_project ();
 
     for (int i = 1; i < words.size (); i++)
@@ -287,6 +291,11 @@
 	  {
 	    in_error = true;
-
-	    CmtError::set (CmtError::syntax_error, "ParseRequirements> bad strategy keyword");
+	    char num[32]; sprintf (num, "%d", line_number);
+	    CmtError::set (CmtError::syntax_error,
+			   project->get_name ()
+			   + " project file: " + file_name
+			   + ": line: " + num
+			   + ": " + value + ": Bad strategy value");
+	    //CmtError::set (CmtError::syntax_error, "ParseRequirements> bad strategy keyword");
 	  }
       }
@@ -1060,4 +1069,5 @@
 	       int line_number)
   {
+    /*
     cmt_string cmtpath;
     cmt_string offset;
@@ -1066,4 +1076,7 @@
 
     Project* p = Project::find_by_cmtpath (cmtpath);
+    */
+    Project* p = const_cast<Project*>(use->get_project ());
+    //    const Project* p = use->get_project ();
 
     for (int i = 1; i < words.size (); i++)
@@ -1126,6 +1139,11 @@
 	  {
 	    in_error = true;
-
-	    CmtError::set (CmtError::syntax_error, "ParseRequirements> bad strategy keyword");
+	    char num[32]; sprintf (num, "%d", line_number);
+	    CmtError::set (CmtError::syntax_error,
+			   project->get_name ()
+			   + " project file: " + file_name
+			   + ": line: " + num
+			   + ": " + value + ": Bad strategy value");
+	    //CmtError::set (CmtError::syntax_error, "ParseRequirements> bad strategy keyword");
 	  }
       }
@@ -1164,4 +1182,5 @@
 	       int line_number)
   {
+    /*
     cmt_string cmtpath;
     cmt_string offset;
@@ -1170,4 +1189,7 @@
 
     Project* p = Project::find_by_cmtpath (cmtpath);
+    */
+    Project* p = const_cast<Project*>(use->get_project ());
+    //    const Project* p = use->get_project ();
 
     for (int i = 1; i < words.size (); i++)
@@ -1231,6 +1253,11 @@
 	  {
 	    in_error = true;
-
-	    CmtError::set (CmtError::syntax_error, "ParseRequirements> bad strategy keyword");
+	    char num[32]; sprintf (num, "%d", line_number);
+	    CmtError::set (CmtError::syntax_error,
+			   project->get_name ()
+			   + " project file: " + file_name
+			   + ": line: " + num
+			   + ": " + value + ": Bad strategy value");
+	    //CmtError::set (CmtError::syntax_error, "ParseRequirements> bad strategy keyword");
 	  }
       }
@@ -1403,5 +1430,5 @@
       //
       
-      Project* p = use->get_project ();
+      const Project* p = use->get_project ();
       if (p != 0)
         {      
@@ -2054,3 +2081,6 @@
 
   keyword->action (words, project, file_name, line_number);
+
+  if (CmtError::get_last_error_code () == CmtError::syntax_error)
+    CmtError::print ();
 }
Index: CMT/v1r25-branch/source/cmt_system.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_system.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_system.cxx	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_system.h
===================================================================
--- CMT/v1r25-branch/source/cmt_system.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt_system.h	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
Index: CMT/v1r25-branch/source/cmt_tag.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_tag.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_tag.cxx	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
@@ -99,4 +100,8 @@
 
   Log;
+
+  const CmtSystem::cmt_string_vector& tags_remove = Cmt::get_tags_remove ();
+  for (int i = tags_remove.size () - 1; i >= 0; i--)
+    if (tags_remove[i] == m_name) return;
 
   if (m_tag_excludes.size () > 0)
@@ -231,4 +236,27 @@
 
       tag->mark (use ? use->get_package_name () : "");
+
+      Use::UsePtrVector * puses;
+      if (!(puses = apply_tag ().find (tag)))
+	{
+	  Use::UsePtrVector uses;
+	  uses.push_back (use);
+	  apply_tag ().add (tag, uses);
+	}
+      else
+	{
+	  bool have (false);
+	  for (int i = 0; i < puses->size (); i++)
+	    {
+	      if ((*puses)[i] == use)
+		{
+		  have = true;
+		  break;
+		}
+	    }
+	  if (!have)
+	    puses->push_back (use);
+	}
+
     }
 }
@@ -603,6 +631,14 @@
   if (tag->m_tag_refs.size () > 0) return (true);
   if (tag->m_tag_excludes.size () > 0) return (true);
+  if (apply_tag ().has (tag)) return (true);
 
   return (false);
+}
+
+/*----------------------------------------------------------*/
+Tag::TagUses& Tag::apply_tag ()
+{
+  static TagUses tag_uses;
+  return tag_uses;
 }
 
@@ -823,4 +859,24 @@
 	  out << "]";
 	}
+
+      if (Use::UsePtrVector * puses = apply_tag ().find (this))
+	{
+	  out << " applied [";
+	  for (int i = 0; i < puses->size (); i++)
+	    {
+	      if (i > 0) out << " ";
+	      Use * use = (*puses)[i];
+	      if (use)
+		{
+		  out << use->get_package_name ();
+		}
+	      else
+		{
+		  out << "current";
+		}
+	    }
+	  out << "]";
+	}
+
       if (m_act_context.size () != 0 &&
 	  (m_def_use != 0 &&
Index: CMT/v1r25-branch/source/cmt_tag.h
===================================================================
--- CMT/v1r25-branch/source/cmt_tag.h	(revision 646)
+++ CMT/v1r25-branch/source/cmt_tag.h	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
@@ -19,4 +20,6 @@
   typedef cmt_vector<Tag> TagVector;
   typedef cmt_vector<Tag*> TagPtrVector;
+
+  typedef cmt_vmap<const Tag*, Use::UsePtrVector> TagUses;
 
   static void action (const CmtSystem::cmt_string_vector& words, Use* use);
@@ -40,4 +43,6 @@
 
   static bool check_tag_used (const Tag* tag);
+
+  static TagUses& apply_tag ();
 
 public:
Index: CMT/v1r25-branch/source/cmt_triggers.cxx
===================================================================
--- CMT/v1r25-branch/source/cmt_triggers.cxx	(revision 646)
+++ CMT/v1r25-branch/source/cmt_triggers.cxx	(revision 664)
@@ -2,4 +2,5 @@
 // Copyright Christian Arnault LAL-Orsay CNRS
 // arnault@lal.in2p3.fr
+// Modified by Grigory Rybkin
 // See the complete license in cmt_license.txt "http://www.cecill.info". 
 //-----------------------------------------------------------
